; + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + +
; WINGSPAN PLOT WIDGET
PRO GET_HC_EVENT, MAKE_HC, ZOOM_HC

COMMON TWIDS, WIDS


; Assume no hardcopy, no zoom
MAKE_HC = 0
ZOOM_HC = 0

EVENT = WIDGET_EVENT(WIDS.HC_BASE)

TYPE = TAG_NAMES(EVENT, /STRUCTURE)
; The button widget events
WIDGET_CONTROL, EVENT.ID, GET_VALUE=VALUE, GET_UVALUE=UVALUE
CASE 1 OF 

     VALUE EQ 'DONE': BEGIN          
           WIDGET_CONTROL, EVENT.TOP, /DESTROY
           END
     VALUE EQ 'Create Hardcopy': BEGIN           
           MAKE_HC = 1
           END
     VALUE EQ 'Zoom': BEGIN          
           ZOOM_HC = 1
           END

ENDCASE ; for VALUE



END
; - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
PRO W_HARDCOPY, MTITLE, WNOTES, $
    BIG = BIG, NOINQUIRE = NOINQUIRE, ZOOM = ZOOM, NODONE = NODONE
; WNOTES is a string array that can optionally be added 
; Set NOINQUIRE to omit the option to create a hardcopy
; Set NODONE to omit the DONE button
; Set ZOOM to add a zoom button

COMMON TWIDS, WIDS
COMMON THE_SCREEN, CURRENT_SCREEN
COMMON WSP_CONTROL_C, $
       CV_DEBUG, CV_TALKY, CV_EXP_USER, CV_CONTOUR_CHOICE, $
       CV_WRITE_CONTOUR_CHI_STEPS, CV_AUTO_COMMENT, $
       CV_FIRST_BIN_CALC, CV_LAST_BIN_CALC, $
       CV_BATCH_FIT_SUMMARY, CV_GAUSS_OFFSET, $
       CV_START_GAUSS_E, CV_END_GAUSS_E, CV_GAUSS_STEP_SIZE, $
       CV_GAUSS_VWIDTH, CV_FIX_UNDETERMINED, CV_AXES_SAME, $
  
       CV_PRINTER_LANG, CV_PLOT_MODEL_EXTRAP, $
       CV_PLOT_EACH_TERM, CV_ABS_MODEL, CV_PLOT_ONLY_DATA, $
       CV_SUPPRESS_2ND_LABELS, CV_MULTI_DET_PLOT_MODE, $
       CV_GRAPH_LIMIT_MODE, CV_HCOPY_FILE_STATUS, $
       CV_ENCAPSULATED_PS, CV_SPEC_STYLE, $

       CV_RATE_MODE, CV_TRACK_MOUSE, CV_PLOT_UNDETERMINED, $
       CV_PLOT_CURSOR, CV_IDL_RETAIN, CV_TITLE_STYLE, $
       CV_SPARE_1, CV_SPARE_2, CV_SPARE_3, $

       CV_KEEP_ASCII_OPEN, CV_ASCII_OUT_FILE, $
       CV_STARTUP_TEMPLATE_FILE, CV_FULL_BATCH_OUT, $
       CV_SUPPRESS_BATCH_OUT, CV_BATCH_OUT_FILE, CV_ALWAYS_WA, $
       CV_ALWAYS_WB, $

       CV_REL_CONVERG, CV_ABS_CONVERG, CV_MAX_TRIES

DEVICE, RETAIN = CV_IDL_RETAIN

; Parent
IF N_ELEMENTS(MTITLE) NE 0 THEN MTITL = MTITLE ELSE MTITL = ''
WIDS.HC_BASE = WIDGET_BASE(TITLE = MTITL, /COLUMN)
            
 IF NOT KEYWORD_SET(NODONE) THEN BEGIN
    HC_BUT1 = WIDGET_BUTTON(WIDS.HC_BASE, VALUE = 'DONE')
 ENDIF

 IF NOT KEYWORD_SET(NOINQUIRE) THEN BEGIN
    HC_BUT2   = WIDGET_BUTTON(WIDS.HC_BASE, VALUE = 'Create Hardcopy')
 ENDIF
                                 
 IF KEYWORD_SET(ZOOM) THEN BEGIN
    HC_BUT3 = WIDGET_BUTTON(WIDS.HC_BASE, VALUE = 'Zoom')
 ENDIF

 ; Place to add any notes
 IF N_ELEMENTS(WNOTES) NE 0 THEN BEGIN
    NBASE  = WIDGET_BASE(WIDS.HC_BASE, /COLUMN)
    FOR i=0, N_ELEMENTS(WNOTES)-1 DO BEGIN
        WIDS.HC_STATUS = WIDGET_TEXT(NBASE, VALUE = WNOTES(i))
    ENDFOR
 ENDIF

 ; The draw widget
 IF KEYWORD_SET(BIG) THEN BEGIN
    XFACTOR = 0.75
    YFACTOR = 0.75
 ENDIF ELSE BEGIN
    XFACTOR = 0.50
    YFACTOR = 0.50
 ENDELSE
 WIDS.HC_DRAW = WIDGET_DRAW(WIDS.HC_BASE, XSIZE = CURRENT_SCREEN(0)*XFACTOR, $
                            YSIZE = CURRENT_SCREEN(1)*YFACTOR, /FRAME)

; Realize the BASE widget and the children
WIDGET_CONTROL, WIDS.HC_BASE, /REALIZE, SHOW = 1 

; Place the cursor on DONE button, if it exists
IF NOT KEYWORD_SET(NODONE) THEN BEGIN
   WIDGET_CONTROL, HC_BUT1, /INPUT_FOCUS
ENDIF  

; Get the draw widget window number
WIDGET_CONTROL, GET_VALUE = WPLOT_WINDOW, WIDS.HC_DRAW
WSET, WPLOT_WINDOW



END
; - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
