; This file adds user-defined external routines to WINGSPAN.
; Add your entry to the menu defined by EXTERNAL_ROUTINES, and
;  initiate the program in the CASE statement.

PRO W_EXTERNAL_ROUTINES

@wgsp_cb.pro


NEW_MENU:
EXTERNAL_ROUTINES = ['CANCEL', $
                     'Line Search File', $
                     'Make DRM', $
                     'BFITS', $
                     'Pulsar Timing Analysis', $
                     'T90', $
                     'Flux Fluence Generator']

; Create a popup menu
CHOICE = WIDMENU( EXTERNAL_ROUTINES )

; Add your PROCEDURE call in this CASE statement
EXTERNAL_ROUTINES_CASE = STRUPCASE(EXTERNAL_ROUTINES)
CASE EXTERNAL_ROUTINES_CASE(CHOICE) OF

     'CANCEL':

     'LINE SEARCH FILE': WM_WRITE_LINEFIT

     'MAKE DRM': MAKE_DRM
     'BFITS': W_BFITS

     'PULSAR TIMING ANALYSIS' : BEGIN
        ERR = WIDMENU(['Not Implemented', 'OK'], TITLE = 0, WIDTH = 200)
        GOTO, NEW_MENU
        END

     'T90': BEGIN
        ERR = WIDMENU(['Not Implemented', 'OK'], TITLE = 0, WIDTH = 200)
        GOTO, NEW_MENU
        END

     'FLUX FLUENCE GENERATOR': BEGIN
        ERR = WIDMENU(['Not Implemented', 'OK'], TITLE = 0, WIDTH = 200)
        GOTO, NEW_MENU
        END

     ELSE: BEGIN
        ERR = WIDMENU(['Error in W_EXTERNAL_ROUTINES.PRO', 'OK'], $
                       TITLE = 0, WIDTH = 200)
        GOTO, NEW_MENU
        END

ENDCASE




END
